from functools import cache

import numpy as np


class NameGenerator:

    def __init__(self):
        self.uuid = 0

    def generate_object_name(self):
        self.uuid += 1
        return f"HCSS{self.uuid}"

    def generate_planet_name(self):
        return np.random.choice(PLANET_NAMES)


@cache
def get_instance(name: str = "singleton") -> NameGenerator:
    return NameGenerator()


PLANET_NAMES = [
    "Achelous",
    "Oceanu",
    "Siren",
    "Acheron",
    "Achilles",
    "Actaeon",
    "Admetus",
    "Adoni",
    "Aeacus",
    "Aeëtes",
    "Aegisthus",
    "Aegyptus",
    "Aeneas",
    "Aeolus",
    "Asclepiu",
    "Agamemnon",
    "Aglaia",
    "Ajax",
    "Alcestis",
    "Alcyone",
    "Pleiades",
    "Furies",
    "Althaea",
    "Amazons",
    "Ero",
    "Amphion",
    "Amphitrite",
    "Amphitryon",
    "Anchises",
    "Andromache",
    "Andromeda",
    "Anteros",
    "Antigone",
    "Antinoüs",
    "Venus",
    "Apollo",
    "Aquilo",
    "Arachne",
    "Mars",
    "Argo",
    "Argus",
    "Ariadne",
    "Arion",
    "Artemis",
    "Asclepius",
    "Astarte",
    "Sterop",
    "Astraea",
    "Atalanta",
    "Minerva",
    "Atlas",
    "Atreus",
    "Atropos",
    "Fates",
    "Eo",
    "Auster",
    "Avernus",
    "Dionysu",
    "Bellerophon",
    "Bellona",
    "Boreas",
    "Cadmus",
    "Calliope",
    "Muses",
    "Calypso",
    "Cassandra",
    "Castor",
    "Centaurs",
    "Cephalus",
    "Cepheus",
    "Cerberus",
    "Demete",
    "Chaos",
    "Charon",
    "Charybdis",
    "Chiron",
    "Chryseis",
    "Circe",
    "Clio",
    "Clotho",
    "Clytemnestra",
    "Saturn",
    "Cyclopes",
    "Daedalus",
    "Danae",
    "Danaïdes",
    "Danaüs",
    "Daphne",
    "Graeae",
    "Ceres",
    "Artemi",
    "Dido",
    "Diomedes",
    "Dione",
    "Bacchus",
    "Dioscuri",
    "Plut",
    "Hade",
    "Dryads",
    "Echo",
    "Electra",
    "Endymion",
    "Enyo",
    "Eos",
    "Aurora",
    "Erato",
    "Erebus",
    "Eris",
    "Eros",
    "Eteocles",
    "Euphrosyne",
    "Europa",
    "Eurus",
    "Gorgons",
    "Eurydice",
    "Eurystheus",
    "Euterpe",
    "Fauns",
    "Faunus",
    "Pa",
    "Favonius",
    "Flora",
    "Fortuna",
    "Gaea",
    "Galatea",
    "Ganymede",
    "Golden Fleece",
    "Graces",
    "Hades",
    "Hamadryads",
    "Harpies",
    "Juventas",
    "Hecate",
    "Hector",
    "Hecuba",
    "Helen",
    "Helios",
    "Sol",
    "Vulcan",
    "Hera",
    "Juno",
    "Hercules",
    "Mercury",
    "Hero",
    "Hesperus",
    "Hestia",
    "Vesta",
    "Hippolyte",
    "Amazon",
    "Hippolytus",
    "Hippomenes",
    "Hyacinthus",
    "Hydra",
    "Hyperion",
    "Hypnos",
    "Somnus",
    "Iapetus",
    "Icarus",
    "Io",
    "Iobates",
    "Iphigenia",
    "Iris",
    "Ismene",
    "Ixion",
    "Janus",
    "Jocasta",
    "Zeu",
    "Heb",
    "Laius",
    "Laocoön",
    "Lares",
    "Let",
    "Lavinia",
    "Leda",
    "Lethe",
    "Leto",
    "Latona",
    "Maia",
    "Manes",
    "Marsyas",
    "Medea",
    "Medusa",
    "Meleager",
    "Melpomene",
    "Memnon",
    "Menelaus",
    "Mentor",
    "Herme",
    "Merope",
    "Midas",
    "Athen",
    "Minos",
    "Minotaur",
    "Mnemosyne",
    "Muse",
    "Momus",
    "Morpheus",
    "Thanato",
    "Naiads",
    "Napaeae",
    "Narcissus",
    "Nemesis",
    "Neoptolemus",
    "Poseido",
    "Nestor",
    "Nike",
    "Niobe",
    "Notus",
    "Ny",
    "Nymphs",
    "Nyx",
    "Oceanids",
    "Oceanus",
    "Odysseus",
    "Ulysses",
    "Oedipus",
    "Oenone",
    "Rhe",
    "Orestes",
    "Furie",
    "Orion",
    "Orpheus",
    "Pan",
    "Pandora",
    "Parcae",
    "Paris",
    "Patroclus",
    "Pegasus",
    "Pelias",
    "Pelops",
    "Penates",
    "Penelope",
    "Persephone",
    "Proserpine",
    "Perseus",
    "Phaedra",
    "Phaethon",
    "Philoctetes",
    "Phineus",
    "Phlegethon",
    "Pirithous",
    "Pluto",
    "Pollux",
    "Polyhymnia",
    "Polymnia",
    "Polynices",
    "Polyphemus",
    "Polyxena",
    "Pontus",
    "Poseidon",
    "Neptune",
    "Priam",
    "Priapus",
    "Procrustes",
    "Prometheus",
    "Persephon",
    "Proteus",
    "Psyche",
    "Pygmalion",
    "Pyramus",
    "Python",
    "Quirinus",
    "Rhadamanthus",
    "Rhea",
    "Ops",
    "Romulus",
    "Sarpedon",
    "Cronu",
    "Satyrs",
    "Scylla",
    "Selene",
    "Semele",
    "Sileni",
    "Silvanus",
    "Sirens",
    "Sisyphus",
    "Helio",
    "Hypno",
    "Sphinx",
    "Styx",
    "Symplegades",
    "Syrinx",
    "Tantalus",
    "Tartarus",
    "Telemachus",
    "Tellus",
    "Terminus",
    "Terpsichore",
    "Thalia",
    "Thanatos",
    "Mors",
    "Themis",
    "Theseus",
    "Thisbe",
    "Thyestes",
    "Tiresias",
    "Titans",
    "Tithonus",
    "Triton",
    "Turnus",
    "Odysseu",
    "Urania",
    "Uranus",
    "Aphrodit",
    "Hesti",
    "Hephaestu",
    "Zephyrus",
    "Jupiter",
    "Aeternae",
    "Alcyoneus",
    "giant",
    "Almops",
    "Poseidon",
    "Helle",
    "Aloadae",
    "Ares",
    "Amphisbaena",
    "Arae",
    "Argus",
    "Asterius",
    "Athos",
    "Briareus",
    "Catoblepas",
    "Centaur",
    "Centauride",
    "Agrius",
    "Heracles",
    "Amycus",
    "Centauromachy",
    "Asbolus",
    "Bienor",
    "Centaurus",
    "Chiron",
    "heroes",
    "Chthonius",
    "Nestor",
    "Pirithous",
    "Hippodamia",
    "Cyllarus",
    "Dictys",
    "Elatus",
    "Eurynomos",
    "Eurytion",
    "Eurytus",
    "Lapiths",
    "Hylaeus",
    "Atalanta",
    "Hylonome",
    "Nessus",
    "Perimedes",
    "Phólos",
    "Pholus",
    "Rhaecus",
    "Thaumas",
    "Cyprus",
    "Lamos",
    "Zeus",
    "Dionysus",
    "Hera",
    "Amphithemis",
    "Cerastes",
    "Cerberus",
    "Hades",
    "Cetus",
    "Ceuthonymus",
    "Menoetius",
    "Charon",
    "Styx",
    "Charybdis",
    "Chimera",
    "Crocotta",
    "Cyclopes",
    "Arges",
    "Gaia",
    "Uranus",
    "Tartarus",
    "Polyphemus",
    "Hephaestus",
    "Daemons",
    "Ceramici",
    "Damysus",
    "Thrace",
    "Dryad",
    "Echion",
    "Eidolon",
    "Empusa",
    "Enceladus",
    "Athena",
    "Erinyes",
    "Cronus",
    "Virgil",
    "Alecto",
    "Megaera",
    "Tisiphone",
    "Gegenees",
    "Gello",
    "Geryon",
    "Gigantes",
    "Gorgons",
    "Euryale",
    "Medusa",
    "Stheno",
    "Graeae",
    "Griffin",
    "Harpies",
    "Aello",
    "Celaeno",
    "Ocypete",
    "Hecatonchires",
    "Hippalectryon",
    "Hippocampus",
    "Lernaean Hydra",
    "Lerna",
    "Labour",
    "Ichthyocentaurs",
    "Ipotane",
    "Keres",
    "Achlys",
    "Kobaloi",
    "Laestrygonians",
    "Antiphates",
    "Manticore",
    "Mimas",
    "Minotaur",
    "Theseus",
    "Hellhound",
    "Orthrus",
    "Odontotyrannos",
    "Onocentaur",
    "Ophiotaurus",
    "Orion",
    "Ouroboros",
    "Pallas",
    "Panes",
    "Periboea",
    "Giantess",
    "Phoenix",
    "Polybotes",
    "Porphyrion",
    "Satyrs",
    "Satyresses",
    "Pan",
    "Agreus",
    "Ampelos",
    "Marsyas",
    "Nomios",
    "Silenus",
    "Scylla",
    "nereid",
    "Circe",
    "Sirens",
    "Medea",
    "Pasiphaë",
    "Argo",
    "Sphinx",
    "Hieracosphinx",
    "Taraxippi",
    "Thoon",
    "Tityos",
    "Triton",
    "Amphitrite",
    "Typhon",
    "Monocerata",
    "Lamiai",
    "Empousa",
    "Lamia",
    "Mormo",
    "Mormolykeia",
    "Hecate",
    "Agriopas",
    "Damarchus",
    "Parrhasia",
    "Lykaia",
    "Lycaon",
    "Nyctimus",
    "Pegasus",
    "Acanthis",
    "Carduelis",
    "Alectryon",
    "Aphrodite",
    "Helios",
    "Autonous",
    "Gerana",
    "Oenoe",
    "Aethon",
    "Lark",
    "Alcyone",
    "Alkyonides",
    "halcyons",
    "Ceyx",
    "Aëdon",
    "Procne",
    "Nyctimene",
    "Ascalaphus",
    "Philomela",
    "Cornix",
    "Coronis",
    "Corvus",
    "Apollo",
    "Cycnus",
    "Phaethon",
    "Eridanos",
    "Strix",
    "Tereus",
    "Hoopoe",
    "Ionia",
    "Crommyon",
    "Gadflies",
    "Myrmekes",
    "Menoetes",
    "Cercopes",
    "Actaeon",
    "panthers",
    "Argos",
    "Odysseus",
    "Laelaps",
    "Maera",
    "Erigone",
    "Arion",
    "Taras",
    "Styx",
    "Achilles",
    "Balius",
    "Xanthus",
    "Ladon",
    "Nemea",
    "Mysia",
    "Trojan",
    "Laocoön",
    "Aeëtes",
    "Talos",
    "Aella",
    "Pan-STARRS I",
    "COAST L",
    "51 Pegasi J",
    "Giausar M",
    "MAGNUM I",
    "Beta Pegasi B",
    "Yed Prior s",
    "Nekkar T",
    "Cursa v",
    "Kraz T",
    "Syrma v",
    "Epsilon Pegasi r",
    "Ursae Minoris g",
    "Polaris v",
    "Beta Scorpii V",
    "Bellatrix H",
    "Acrux V",
    "Merak i",
    "SMARTS k",
    "Kitt V",
    "Merak J",
    "Keck J",
    "Zeta Puppis D",
    "Ran S",
    "Kraz R",
    "Alpha Pavonis f",
    "Kepler q",
    "SMARTS E",
    "Nekkar Y",
    "53 Orionis P",
    "Epsilon Pegasi O",
    "53 Orionis H",
    "Ran W",
    "Ursae Minoris X",
    "Lesath N",
    "Cursa k",
    "Kitt o",
    "TCS L",
    "Toppo  W",
    "Cursa v",
    "SMARTS h",
    "Achird X",
    "Piautos I",
    "53 Orionis e",
    "Schedar Q",
    "Syrma n",
    "Bellatrix t",
    "Alpha Pavonis p",
    "COAST U",
    "Furud Q",
    "CoRoT s",
    "Zosma L",
    "Acrux i",
    "Lesath l",
    "Kraz r",
    "Almaaz x",
    "Sirius d",
    "Ursae Minoris d",
    "MAGNUM e",
    "Keck S",
    "Furud l",
    "Ran s",
    "Alpha Pavonis N",
    "ZIMLAT r",
    "Alpha Pavonis t",
    "Kitt w",
    "Alpha Pavonis I",
    "Lesath j",
    "Polaris B",
    "Diadem K",
    "Kitt X",
    "Toppo  Q",
    "Acrux M",
    "Diadem G",
    "Polaris g",
    "51 Pegasi K",
    "Beta Scorpii F",
    "KAO j",
    "MAGNUM H",
    "Rukbat I",
    "Vega z",
    "Yed Prior y",
    "CHARA Z",
    "Rukbat E",
    "Giausar r",
    "Kraz i",
    "TCS c",
    "Ursae Minoris u",
    "TCS u",
    "CHARA U",
    "Kitt h",
    "Toppo  K",
    "MAGNUM t",
    "Toppo  o",
    "CoRoT O",
    "Ran g",
    "Zosma Y",
    "TCS u",
    "Lesath p",
    "GREGOR  E",
    "COAST v",
    "Kraz V",
    "Acrux V",
    "53 Orionis l",
    "Epsilon Pegasi q",
    "Wezen D",
    "Almaaz x",
    "Furud p",
    "Gamma Leonis Z",
    "Sirius x",
    "Nekkar J",
    "Furud N",
    "Achird U",
    "Toppo  T",
    "Almaaz B",
    "Beta Pegasi j",
    "SMARTS V",
    "Achird n",
    "Giausar O",
    "Kepler k",
    "Furud f",
    "CoRoT D",
    "Lesath g",
    "51 Pegasi e",
    "Bellatrix v",
    "Epsilon Pegasi c",
    "CHARA U",
    "Merak z",
    "CHARA E",
    "CoRoT U",
    "Gamma Leonis U",
    "Rukbat l",
    "Schedar B",
    "Ran O",
    "53 Orionis t",
    "Bellatrix B",
    "Piautos R",
    "Acrux I",
    "Gamma Leonis C",
    "MAGNUM t",
    "Toppo  L",
    "Giausar F",
    "Zosma c",
    "Kraz P",
    "ZIMLAT z",
    "Furud R",
    "Cursa n",
    "Epsilon Pegasi U",
    "AZT-11 u",
    "Sirius N",
]
